#property copyright "Copyright trevone"
#property link "https://www.mql5.com/en/users/trevone" 
#property strict
#property version "7.1"

 
enum manager {
   ALL=0, // ALL
   Send=1, // Send
   Modify=2, // Modify
   Delete=3 // Delete
}; 

extern bool HUD = false; // Chart Info
extern manager TradeManager = 0; // Terminal
extern string TradeComment = "7.1"; // Comment
extern int MagicNumber = 33431; // Magic 
extern int MaxUnprotected = 5; // Total Positions
extern int TradeDeviation = 2; // Total Orders 
extern double FixedLot = 0; // Fixed Lots Disable = 0
extern int TickSample = 16;  // Sample [TICKS] 
extern double RiskPercent = 5.0; // Margin [PERCENT]
extern int Slippage = 3; // Slippage [POINTS]
extern int MinSignal = 7; // Minimum Signal [POINTS]
double ExtendSignal = 0.2; // Extend Signal 
extern int MaxSpread = 14; // Spread Filter [POINTS] 
extern double VelocitySignal = 4.5; // Velocity Signal [SPREADS]
extern double TradeDelta = 1.2; // Order Distance [SPREADS]
extern double Trailing = 0.9; // Trailing Distance [SPREADS]  
extern double TrailingTarget = 7; // Trailing Distance [SPREADS]  
extern double InitialStop = 2.0; // Initial Stop [SPREADS] 
extern double Stoploss = 3.0; // Stop Loss [SPREADS] Disable = 0
extern double TakeProfit = 0.0; // Take Profit [SPREADS] Disable = 0

bool calculateCommission = true;
int OrderExpiry = 15;  
int r, gmt, brokerOffset, size, digits, stoplevel,  max_allowed_orders, highestTickIndex, lowestTickIndex;

double marginRequirement, commissionPoints, maxLot, minLot, lotStep, lotSize, points, currentSpread, avgSpread, maxSpread, actualSpread,
totalSpread, initialBalance, rateChangeBid, rateChangeAsk, lowestPrice, highestPrice, openSpread;

double spreadSize[]; 
double tickBid[];
double tickAsk[];    
double rate = 0; 

int init() {   
   rate = 0;   
   calculateCommission = true;
   marginRequirement = MarketInfo( Symbol(), MODE_MARGINREQUIRED ) * 0.01;
   maxLot = ( double ) MarketInfo( Symbol(), MODE_MAXLOT );  
   minLot = ( double ) MarketInfo( Symbol(), MODE_MINLOT );   
   lotStep = MarketInfo( Symbol(), MODE_LOTSTEP );
   max_allowed_orders = ( int ) AccountInfoInteger( ACCOUNT_LIMIT_ORDERS );
   stoplevel = ( int ) MathMax( MarketInfo( Symbol(), MODE_FREEZELEVEL ), MarketInfo( Symbol(), MODE_STOPLEVEL ) );
   if( stoplevel > TradeDelta ) TradeDelta = stoplevel +1 ;
   if( stoplevel > Trailing ) Trailing = stoplevel +1 ;
   avgSpread = NormalizeDouble( Ask - Bid, Digits ); 
   totalSpread = avgSpread;
   size = TickSample; 
   ArrayResize( tickBid, size ); 
   ArrayFill( tickBid, 0, size, Bid ); 
   ArrayResize( tickAsk, size ); 
   ArrayFill( tickAsk, 0, size, Ask ); 
   ArrayResize( spreadSize, size ); 
   ArrayFill( spreadSize, 0, size, avgSpread );
   maxSpread = NormalizeDouble( avgSpread * Point, Digits ); 
   lotSize();
   display();
   return ( 0 );
}

void commission(){   
   for( int pos = OrdersHistoryTotal() - 1; pos >= 0; pos-- ) {
      if( OrderSelect( pos, SELECT_BY_POS, MODE_HISTORY ) ) {
         if( OrderProfit() != 0.0 ) {
            if( OrderClosePrice() != OrderOpenPrice() ) {
               if( OrderSymbol() == Symbol() ) {
                  calculateCommission = false;
                  rate = MathAbs( OrderProfit() / MathAbs( OrderClosePrice() - OrderOpenPrice() ) );
                  commissionPoints = ( -OrderCommission() ) / rate;   
                  break;
               }
            }
         }
      }
   }  
}
 
int start() {   
   int totalBuyStop = 0, totalSellStop = 0, totalUnprotectedBuy = 0, totalUnprotectedSell = 0, ticket;  
   double target = 0.0, stoploss = 0.0, price = 0.0, trailing, a, b, absProfit;   
   int orderExpiry = ( int ) TimeCurrent() + ( 60 * OrderExpiry );  
   manageTicks();
   if( calculateCommission ) commission();
   prepareSpread(); 
   for( int pos = OrdersTotal() - 1; pos >= 0; pos-- ) {
      r = OrderSelect( pos, SELECT_BY_POS, MODE_TRADES );
      if( OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber ) continue; 
         switch ( OrderType() ) {
            case OP_BUYSTOP:
               totalBuyStop++;
               totalUnprotectedBuy++;
               if( TradeManager == 0 || TradeManager == 3 )
                  if( avgSpread > MaxSpread * Point || rateChangeBid < VelocitySignal * totalSpread ) {
                     r = OrderDelete( OrderTicket() );  
                  }
            break;
            case OP_SELLSTOP:
               totalSellStop++;
               totalUnprotectedSell++;
               if( TradeManager == 0 || TradeManager == 3 )
                  if( avgSpread > MaxSpread * Point || rateChangeAsk > -VelocitySignal * totalSpread ) {
                     r = OrderDelete( OrderTicket() );  
                  }
            break;
            case OP_BUY:   
               if( OrderStopLoss() == 0.0 || ( OrderStopLoss() > 0.0 && OrderStopLoss() < OrderOpenPrice() ) ) totalUnprotectedBuy++;  
               if( TradeManager == 0 || TradeManager == 2 ) 
                  if( OrderStopLoss() == 0.0 || ( OrderOpenPrice() - OrderStopLoss() > InitialStop * totalSpread && OrderStopLoss() < OrderOpenPrice() ) ){
                     openSpread = MathMax( OrderOpenPrice() - Bid, Ask - Bid ) ;
                     if( OrderStopLoss() == 0.0 || NormalizeDouble( Bid - ( InitialStop * openSpread ), Digits ) > OrderStopLoss() )
                        r = OrderModify( OrderTicket(), OrderOpenPrice(), NormalizeDouble( Bid - ( InitialStop * openSpread ), Digits ), OrderTakeProfit(), 0 ); 
                  } else { 
                     absProfit = MathMax( Bid - OrderOpenPrice(), 0 );
                     trailing = MathMax( mapValue( absProfit, commissionPoints, TrailingTarget * totalSpread, Point, Trailing * totalSpread ), stoplevel * Point );
                     if( Bid - trailing > OrderOpenPrice() - Point ){
                        b = Bid; 
                     } else {
                        b = Ask - totalSpread;
                        trailing = MathMax( openSpread, Trailing * totalSpread );
                     } 
                     if( OrderStopLoss() == 0.0 || b - OrderStopLoss() > trailing )
                        if( NormalizeDouble( b - trailing, Digits ) != OrderStopLoss() ) 
                           r = OrderModify( OrderTicket(), OrderOpenPrice(), NormalizeDouble( b - trailing, Digits ), OrderTakeProfit(), 0 );  
                  }  
            break;
            case OP_SELL:
               if( OrderStopLoss() == 0.0 || ( OrderStopLoss() > 0.0 && OrderStopLoss() > OrderOpenPrice() ) ) totalUnprotectedSell++; 
               if( TradeManager == 0 || TradeManager == 2 ) 
                  if( OrderStopLoss() == 0.0 || ( OrderStopLoss() - OrderOpenPrice() > InitialStop * totalSpread && OrderStopLoss() > OrderOpenPrice() ) ){
                     openSpread = MathMax( Ask - OrderOpenPrice(), Ask - Bid ) ;
                     if( OrderStopLoss() == 0.0 || NormalizeDouble( Ask + ( InitialStop * openSpread ), Digits ) < OrderStopLoss() )
                        r = OrderModify( OrderTicket(), OrderOpenPrice(), NormalizeDouble( Ask + ( InitialStop * openSpread ), Digits ), OrderTakeProfit(), 0 );
                  } else { 
                     absProfit = MathMax( OrderOpenPrice() - Ask, 0 );
                     trailing = MathMax( mapValue( absProfit, commissionPoints, TrailingTarget * totalSpread, Point, Trailing * totalSpread ), stoplevel * Point );
                     if( Ask + trailing < OrderOpenPrice() + Point ){
                        a = Ask; 
                     } else {
                        a = Bid + totalSpread;
                        trailing = MathMax( openSpread, Trailing * totalSpread );
                     }  
                     if( OrderStopLoss() == 0.0 || OrderStopLoss() - a > trailing ) 
                        if( NormalizeDouble( a + trailing , Digits ) != OrderStopLoss() ) 
                           r = OrderModify( OrderTicket(), OrderOpenPrice(), NormalizeDouble( a + trailing, Digits ), OrderTakeProfit(), 0 );  
                  }  
            break;
         }   
   }  
   if( TradeManager == 0 || TradeManager == 1 ) 
      if(  ( OrdersTotal() < max_allowed_orders || max_allowed_orders == 0 ) && avgSpread + commissionPoints <= MaxSpread * Point ) { 
         if( totalUnprotectedBuy < MaxUnprotected && rateChangeBid > VelocitySignal * totalSpread && totalBuyStop < TradeDeviation ) {
            if( AccountFreeMarginCheck( Symbol(), OP_BUY, lotSize() ) <= 0 || GetLastError() == 134 ) return ( 0 ); 
            price = NormalizeDouble( Ask + ( totalBuyStop + 1.0 ) * ( TradeDelta * totalSpread ), Digits );
            if( TakeProfit > 0.0 ) target = NormalizeDouble( price + ( TakeProfit * totalSpread ), Digits );
            if( Stoploss > 0.0 ) stoploss = NormalizeDouble( price - ( Stoploss * totalSpread ), Digits );
            ticket = OrderSend( Symbol(), OP_BUYSTOP, lotSize(), price, Slippage, stoploss, target, TradeComment, MagicNumber, 0 ); 
            return ( 0 );
         } 
         if( totalUnprotectedSell < MaxUnprotected && rateChangeAsk < -VelocitySignal * totalSpread && totalSellStop < TradeDeviation ) {
            if( AccountFreeMarginCheck( Symbol(), OP_SELL, lotSize() ) <= 0 || GetLastError() == 134 ) return ( 0 ); 
            price = NormalizeDouble( Bid - ( totalSellStop + 1.0 ) * ( TradeDelta * totalSpread ), Digits );
            if( TakeProfit > 0.0 ) target = NormalizeDouble( price - ( TakeProfit * totalSpread ), Digits );
            if( Stoploss > 0.0 ) stoploss = NormalizeDouble( price + ( Stoploss * totalSpread ), Digits );
            ticket = OrderSend( Symbol(), OP_SELLSTOP, lotSize(), price, Slippage, stoploss, target, TradeComment, MagicNumber, 0 ); 
            return ( 0 );
         }    
      }   
   ObjectsDeleteAll();
   display();  
   return ( 0 );
}

double mapValue( double actualSource, double minSource, double maxSource, double minDestination, double maxDestination ){  
   if( ( maxSource - minSource ) == 0 ) return ( maxDestination ); 
   double map = minDestination + ( ( actualSource - minSource ) / ( maxSource - minSource ) * ( maxDestination - minDestination ) ); 
   double clamp = MathMin( MathMax( minDestination, map ), maxDestination );
   if( minDestination > maxDestination ) clamp = MathMax( MathMin( minDestination, map ), maxDestination ); 
   return ( clamp ); 
} 

double lotSize(){  
   if( FixedLot > 0 ){
      lotSize = FixedLot; 
   } else {
      if( marginRequirement > 0 ) 
         lotSize = ( ( AccountBalance() + AccountCredit() ) * ( ( double ) RiskPercent / 100 ) * 0.01 / marginRequirement );    
   }  
   return ( MathMax( MathMin( NormalizeLots( lotSize ), maxLot ), minLot ) ); 
}  

void prepareSpread(){ 
   double spreadSize_temp[];
   ArrayResize( spreadSize_temp, size - 1 );
   ArrayCopy( spreadSize_temp, spreadSize, 0, 1, size - 1 );
   ArrayResize( spreadSize_temp, size ); 
   spreadSize_temp[size-1] = NormalizeDouble( Ask - Bid, Digits ); 
   ArrayCopy( spreadSize, spreadSize_temp, 0, 0 ); 
   avgSpread = iMAOnArray( spreadSize, size, size, 0, MODE_SMMA, 0 );   
   int maxValueIdx = ArrayMaximum( spreadSize, WHOLE_ARRAY, 0 );
   maxSpread = spreadSize[maxValueIdx]; 
   actualSpread = avgSpread;
   if( avgSpread < MinSignal * Point ) avgSpread = MinSignal * Point; 
   totalSpread = ( maxSpread + commissionPoints ) + ( ( maxSpread + commissionPoints ) * ExtendSignal ); 
   if( totalSpread < MinSignal * Point ) totalSpread = MinSignal * Point;
}       

void manageTicks(){    
   double tickBid_temp[], tickAsk_temp[];
   ArrayResize( tickBid_temp, size - 1 );
   ArrayResize( tickAsk_temp, size - 1 );
   ArrayCopy( tickBid_temp, tickBid, 0, 1, size - 1 ); 
   ArrayCopy( tickAsk_temp, tickAsk, 0, 1, size - 1 ); 
   ArrayResize( tickBid_temp, size ); 
   ArrayResize( tickAsk_temp, size );
   tickBid_temp[size-1] = Bid;
   tickAsk_temp[size-1] = Ask;
   ArrayCopy( tickBid, tickBid_temp, 0, 0 );    
   ArrayCopy( tickAsk, tickAsk_temp, 0, 0 ); 
   int highTickIndex = ArrayMaximum( tickAsk, WHOLE_ARRAY, 0 );
   int lowTickIndex = ArrayMinimum( tickBid, WHOLE_ARRAY, 0 ); 
   if( Ask >= tickAsk[highTickIndex] ) highestTickIndex = 0;
   else highestTickIndex++; 
   if( Bid <= tickBid[lowTickIndex] ) lowestTickIndex = 0;
   else lowestTickIndex++; 
   double priceNowBid = tickBid[size-1];
   double priceThenBid = tickBid[0];   
   rateChangeBid = ( priceNowBid - priceThenBid );
   if( rateChangeBid / Point > 5000 ) rateChangeBid = 0;    
   double priceNowAsk = tickAsk[size-1];
   double priceThenAsk = tickAsk[0];   
   rateChangeAsk = ( priceNowAsk - priceThenAsk );
   if( rateChangeAsk / Point > 5000 ) rateChangeAsk = 0; 
}
/*
double NormalizePrice( double p ){  
   double ts = MarketInfo( Symbol(), MODE_TICKSIZE );
   return( MathRound( p / ts ) * ts );
}*/


double NormalizeLots( double p ){ 
   return( MathRound( p / lotStep ) * lotStep );
}

void display(){   
   if( !HUD ) return;
   string display = " \n"; 
   display = StringConcatenate( display, "  Leverage: ", DoubleToStr( AccountLeverage(), 0 ), ", Lots: ", DoubleToStr( lotSize, 2 ), ", \n" ); 
   display = StringConcatenate( display, "  Spread: ", DoubleToStr( actualSpread / Point, 0 ), ", Max: ", DoubleToStr( maxSpread / Point, 0 ), ", Com: ", DoubleToStr( commissionPoints / Point, 0 ), ", Use: ", DoubleToStr( totalSpread / Point, 0 ), " \n" ); 
   display = StringConcatenate( display, "  Signal: ", DoubleToStr( VelocitySignal * totalSpread / Point, 0 ), ", Distance: ", DoubleToStr( TradeDelta * totalSpread / Point,0), ", Trailing: ", DoubleToStr( Trailing * totalSpread / Point, 0 ), " \n" ); 
   display = StringConcatenate( display, "  Set: ", TradeComment, " \n" ); 
   Comment( display );  
}

// tick trend??
// martingale
// hidden orders 
// avg open price mixed in
// lowest stop mixed min
// martingale lots mixed in 
// delay the secondary
// use avg only if below entry price
// Add slippage to the entry trail


// fix secondary
// use tick index